Index: /trunk/thirds/cgic206/debian/changelog
===================================================================
--- /trunk/thirds/cgic206/debian/changelog	(revision 493)
+++ /trunk/thirds/cgic206/debian/changelog	(revision 493)
@@ -0,0 +1,32 @@
+libcgic (2.06-1~trusty3) trusty; urgency=low
+
+  * New version to be used for ZOO-Kernel.
+
+ -- Angelos Tzotsos <gcpp.kalxas@gmail.com>  Tue, 10 Jun 2014 19:29:04 +0200
+
+libcgic (2.05-3) unstable; urgency=low
+
+  * debian/control: Suggests: httpd.  Closes: #600138.
+  * debian/control: Fixed debhelper-but-no-misc-depends.
+
+ -- Bart Martens <bartm@debian.org>  Sun, 13 May 2012 08:33:04 +0000
+
+libcgic (2.05-2) unstable; urgency=low
+
+  * debian/control: Standards-Version, Homepage.
+
+ -- Bart Martens <bartm@debian.org>  Sun, 13 Jul 2008 09:31:48 +0200
+
+libcgic (2.05-1) unstable; urgency=low
+
+  * New maitnainer.  Closes: #438643.
+  * New upstream release.
+  * debian/*: Repackaged with cdbs.
+  * debian/changelog-upstream.html: Removed.
+  * debian/Makefile.examples: Removed.
+  * debian/README.Debian: Removed.
+  * debian/copyright: Updated.
+  * debian/watch: Updated.
+
+ -- Bart Martens <bartm@knars.be>  Sun, 19 Aug 2007 09:18:53 +0200
+
Index: /trunk/thirds/cgic206/debian/compat
===================================================================
--- /trunk/thirds/cgic206/debian/compat	(revision 493)
+++ /trunk/thirds/cgic206/debian/compat	(revision 493)
@@ -0,0 +1,1 @@
+5
Index: /trunk/thirds/cgic206/debian/control
===================================================================
--- /trunk/thirds/cgic206/debian/control	(revision 493)
+++ /trunk/thirds/cgic206/debian/control	(revision 493)
@@ -0,0 +1,35 @@
+Source: libcgic
+Section: libs
+Priority: optional
+Maintainer: Bart Martens <bartm@debian.org>
+Build-Depends: cdbs, libfcgi-dev, debhelper (>= 5)
+Standards-Version: 3.9.3
+Homepage: http://www.boutell.com/cgic/
+
+Package: libcgic-dev
+Section: libdevel
+Architecture: any
+Depends: libc6-dev, ${misc:Depends}
+Suggests: httpd
+Conflicts: libcgicg1-dev
+Replaces: libcgicg1-dev
+Description: C library for developing CGI applications
+ Cgic is an ANSI-C library for the creation of CGI-based World Wide Web
+ applications.  Cgic provides the following:
+ .
+   * Parses form data, correcting for defective and/or inconsistent
+     browsers
+   * Transparently accepts both GET and POST form data
+   * Handles line breaks in form fields in a consistent manner
+   * Provides string, integer, floating-point, and single- and
+     multiple-choice functions to retrieve form data
+   * Provides bounds checking for numeric fields
+   * Loads CGI environment variables into C strings which are always
+     non-null
+   * Provides a way to capture CGI situations for replay in a debugging
+     environment
+ .
+ This package provides a static library version of cgic, examples of using
+ cgic (including a CGI application that captures a CGI environment for use
+ in debugging), and header files.
+
Index: /trunk/thirds/cgic206/debian/copyright
===================================================================
--- /trunk/thirds/cgic206/debian/copyright	(revision 493)
+++ /trunk/thirds/cgic206/debian/copyright	(revision 493)
@@ -0,0 +1,28 @@
+This package was debianized by Brian Bassett brian@butterfly.ml.org on
+Tue, 11 Nov 1997 17:28:04 -0800.
+
+It was downloaded from:
+
+    http://www.boutell.com/cgic/
+
+Upstream author:
+
+    Thomas Boutell <boutell@boutell.com>
+
+Copyright:
+
+    Copyright (C) 1996-2004 by Thomas Boutell and Boutell.Com, Inc.
+
+License:
+
+    CGIC, copyright 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003,
+    2004 by Thomas Boutell and Boutell.Com, Inc.. Permission is granted to
+    use CGIC in any application, commercial or noncommercial, at no cost.
+    HOWEVER, this copyright paragraph must appear on a "credits" page
+    accessible in the public online and offline documentation of the program.
+    Modified versions of the CGIC library should not be distributed without
+    the attachment of a clear statement regarding the author of the
+    modifications, and this notice may in no case be removed.
+    Modifications may also be submitted to the author for inclusion
+    in the main CGIC distribution.
+
Index: /trunk/thirds/cgic206/debian/libcgic-dev.docs
===================================================================
--- /trunk/thirds/cgic206/debian/libcgic-dev.docs	(revision 493)
+++ /trunk/thirds/cgic206/debian/libcgic-dev.docs	(revision 493)
@@ -0,0 +1,1 @@
+cgic.html
Index: /trunk/thirds/cgic206/debian/libcgic-dev.examples
===================================================================
--- /trunk/thirds/cgic206/debian/libcgic-dev.examples	(revision 493)
+++ /trunk/thirds/cgic206/debian/libcgic-dev.examples	(revision 493)
@@ -0,0 +1,2 @@
+capture.c
+cgictest.c
Index: /trunk/thirds/cgic206/debian/libcgic-dev.install
===================================================================
--- /trunk/thirds/cgic206/debian/libcgic-dev.install	(revision 493)
+++ /trunk/thirds/cgic206/debian/libcgic-dev.install	(revision 493)
@@ -0,0 +1,2 @@
+cgic.h usr/include/
+libcgic.a usr/lib/
Index: /trunk/thirds/cgic206/debian/libcgic-dev.links
===================================================================
--- /trunk/thirds/cgic206/debian/libcgic-dev.links	(revision 493)
+++ /trunk/thirds/cgic206/debian/libcgic-dev.links	(revision 493)
@@ -0,0 +1,1 @@
+/usr/lib/libcgic.so.2.06 /usr/lib/libcgic.so
Index: /trunk/thirds/cgic206/debian/rules
===================================================================
--- /trunk/thirds/cgic206/debian/rules	(revision 493)
+++ /trunk/thirds/cgic206/debian/rules	(revision 493)
@@ -0,0 +1,7 @@
+#!/usr/bin/make -f
+
+include /usr/share/cdbs/1/rules/debhelper.mk
+include /usr/share/cdbs/1/class/makefile.mk
+
+clean::
+	rm -f libcgic.so.2.06
Index: /trunk/thirds/cgic206/debian/watch
===================================================================
--- /trunk/thirds/cgic206/debian/watch	(revision 493)
+++ /trunk/thirds/cgic206/debian/watch	(revision 493)
@@ -0,0 +1,4 @@
+version=3
+opts="uversionmangle=s/^(\d)(\d\d)$/$1.$2/" \
+http://www.boutell.com/cgic/ \
+cgic(.*)\.t.*