Index: /trunk/debian/changelog
===================================================================
--- /trunk/debian/changelog	(revision 494)
+++ /trunk/debian/changelog	(revision 494)
@@ -0,0 +1,12 @@
+zoo-project (1.3.0-1~trusty10) trusty; urgency=low
+
+  * Added OGR ZOO Services.
+
+ -- Angelos Tzotsos <gcpp.kalxas@gmail.com>  Sun, 28 Jul 2014 19:48:00 +0200
+
+zoo-project (1.3.0-1~trusty7) trusty; urgency=low
+
+  * Initial Debian packaging.
+
+ -- Angelos Tzotsos <gcpp.kalxas@gmail.com>  Tue, 10 Jun 2014 21:17:04 +0200
+
Index: /trunk/debian/compat
===================================================================
--- /trunk/debian/compat	(revision 494)
+++ /trunk/debian/compat	(revision 494)
@@ -0,0 +1,1 @@
+9
Index: /trunk/debian/control
===================================================================
--- /trunk/debian/control	(revision 494)
+++ /trunk/debian/control	(revision 494)
@@ -0,0 +1,49 @@
+Source: zoo-project
+Maintainer: Angelos Tzotsos <gcpp.kalxas@gmail.com>
+Section: web
+Priority: optional
+Build-Depends: debhelper (>= 9),
+               dpkg-dev (>= 1.16.1.1),
+               autoconf,
+               automake,
+               autotools-dev,
+               flex,
+               bison,
+               libssl-dev,
+               libcurl4-gnutls-dev,
+               libcgic-dev (>= 2.06),
+               libgdal-dev (>= 1.10.1-0~),
+               python-all (>= 2.6.6-3~),
+               python-all-dev (>= 2.6.6-3~),
+               libfcgi-dev,
+               libxml2-dev,
+               libxslt1-dev,
+               libmapserver1-dev
+Build-Conflicts: libcurl3-openssl-dev
+Standards-Version: 3.9.3
+X-Python-Version: >= 2.6
+Homepage: http://zoo-project.org
+
+Package: zoo-kernel
+Architecture: any
+Section: web
+Depends: ${shlibs:Depends},
+         ${misc:Depends}
+Description: This package contains the CGI ZOO Kernel
+ .
+ ZOO is a WPS (Web Processing Service) open source project released 
+ under a  MIT/X-11 style license . It provides an OGC WPS compliant
+ developer-friendly framework to create and chain WPS Web services. 
+
+Package: zoo-services
+Architecture: any
+Section: web
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+         python (>=2.6), 
+         python-gdal
+Description: This package contains the CGI ZOO Services
+ .
+ ZOO is a WPS (Web Processing Service) open source project released 
+ under a  MIT/X-11 style license . It provides an OGC WPS compliant
+ developer-friendly framework to create and chain WPS Web services. 
Index: /trunk/debian/copyright
===================================================================
--- /trunk/debian/copyright	(revision 494)
+++ /trunk/debian/copyright	(revision 494)
@@ -0,0 +1,37 @@
+This package was debianized by Angelos Tzotsos gcpp.kalxas@gmail.com on
+Tue, 10 Jun 2014 21:17:04 +0200.
+
+It was downloaded from:
+
+    http://zoo-project.org
+
+Upstream author:
+
+    Gerald Fenoy <gerald.fenoy@geolabs.fr>
+
+Copyright:
+
+    Copyright (C) 2010-2011 GeoLabs.
+
+License:
+
+    Permission is hereby granted, free of charge, to any person
+    obtaining a copy of this software and associated documentation
+    files (the "Software"), to deal in the Software without
+    restriction, including without limitation the rights to use, copy,
+    modify, merge, publish, distribute, sublicense, and/or sell copies
+    of the Software, and to permit persons to whom the Software is
+    furnished to do so, subject to the following conditions:
+
+    The above copyright notice and this permission notice shall be
+    included in all copies or substantial portions of the Software.
+
+    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+    NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+    HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+    WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+    DEALINGS IN THE SOFTWARE.
+
Index: /trunk/debian/rules
===================================================================
--- /trunk/debian/rules	(revision 494)
+++ /trunk/debian/rules	(revision 494)
@@ -0,0 +1,25 @@
+#!/usr/bin/make -f
+# -*- makefile -*-
+
+%:
+	dh  $@
+
+override_dh_auto_configure:
+	cd zoo-project/zoo-kernel && autoconf && ./configure --with-python
+
+override_dh_auto_build:
+	dh_auto_build --builddirectory zoo-project/zoo-kernel
+	cd zoo-project/zoo-services/ogr/base-vect-ops && make
+
+override_dh_auto_install:
+	dh_auto_install --builddirectory zoo-project/zoo-kernel
+	-mkdir -p $(CURDIR)/debian/tmp/usr/lib/cgi-bin
+	install -m755 $(CURDIR)/zoo-project/zoo-kernel/zoo_loader.cgi $(CURDIR)/debian/tmp/usr/lib/cgi-bin/
+	-mv -v $(CURDIR)/zoo-project/zoo-kernel/main.cfg $(CURDIR)/debian/tmp/usr/lib/cgi-bin/
+	install -m755 $(CURDIR)/zoo-project/zoo-services/ogr/base-vect-ops/cgi-env/ogr_service.zo $(CURDIR)/debian/tmp/usr/lib/cgi-bin/
+	-mv -v $(CURDIR)/zoo-project/zoo-services/ogr/base-vect-ops/cgi-env/*.zcfg $(CURDIR)/debian/tmp/usr/lib/cgi-bin/
+	install -m755 $(CURDIR)/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/ogr_sp.py $(CURDIR)/debian/tmp/usr/lib/cgi-bin/
+	-mv -v $(CURDIR)/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/*.zcfg $(CURDIR)/debian/tmp/usr/lib/cgi-bin/
+
+override_dh_auto_clean:
+	dh_auto_clean --builddirectory zoo-project/zoo-kernel
Index: /trunk/debian/source/format
===================================================================
--- /trunk/debian/source/format	(revision 494)
+++ /trunk/debian/source/format	(revision 494)
@@ -0,0 +1,1 @@
+3.0 (quilt)
Index: /trunk/debian/zoo-kernel.install
===================================================================
--- /trunk/debian/zoo-kernel.install	(revision 494)
+++ /trunk/debian/zoo-kernel.install	(revision 494)
@@ -0,0 +1,2 @@
+usr/lib/cgi-bin/zoo_loader.cgi
+usr/lib/cgi-bin/main.cfg
Index: /trunk/debian/zoo-services.install
===================================================================
--- /trunk/debian/zoo-services.install	(revision 494)
+++ /trunk/debian/zoo-services.install	(revision 494)
@@ -0,0 +1,21 @@
+usr/lib/cgi-bin/ogr_service.zo
+usr/lib/cgi-bin/ogr_sp.py
+usr/lib/cgi-bin/Boundary.zcfg
+usr/lib/cgi-bin/Buffer.zcfg
+usr/lib/cgi-bin/Centroid.zcfg
+usr/lib/cgi-bin/ConvexHull.zcfg
+usr/lib/cgi-bin/Difference.zcfg
+usr/lib/cgi-bin/Distance.zcfg
+usr/lib/cgi-bin/GetArea.zcfg
+usr/lib/cgi-bin/Intersection.zcfg
+usr/lib/cgi-bin/SymDifference.zcfg
+usr/lib/cgi-bin/Union.zcfg
+usr/lib/cgi-bin/BoundaryPy.zcfg
+usr/lib/cgi-bin/BufferPy.zcfg
+usr/lib/cgi-bin/CentroidPy.zcfg
+usr/lib/cgi-bin/ConvexHullPy.zcfg
+usr/lib/cgi-bin/DifferencePy.zcfg
+usr/lib/cgi-bin/IntersectionPy.zcfg
+usr/lib/cgi-bin/SymDifferencePy.zcfg
+usr/lib/cgi-bin/UnionPy.zcfg
+