Index: trunk/zoo-project/zoo-client/lib/tpl/payload_DescribeProcess.mustache
===================================================================
--- trunk/zoo-project/zoo-client/lib/tpl/payload_DescribeProcess.mustache	(revision 480)
+++ trunk/zoo-project/zoo-client/lib/tpl/payload_DescribeProcess.mustache	(revision 517)
@@ -1,3 +1,3 @@
-<DescribeProcess xmlns="http://www.opengis.net/wps/1.0.0" xmlns:ows="http://www.opengis.net/ows/1.1" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.opengis.net/wps/1.0.0 ../wpsDescribeProcess_request.xsd" service="WPS" version="1.0.0" language="en-CA">
+<DescribeProcess xmlns="http://www.opengis.net/wps/1.0.0" xmlns:ows="http://www.opengis.net/ows/1.1" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.opengis.net/wps/1.0.0 ../wpsDescribeProcess_request.xsd" service="WPS" version="1.0.0" language="{{language}}">
 {{#identifiers}}
   <ows:Identifier>{{.}}</ows:Identifier>
Index: trunk/zoo-project/zoo-client/lib/tpl/payload_Execute.mustache
===================================================================
--- trunk/zoo-project/zoo-client/lib/tpl/payload_Execute.mustache	(revision 480)
+++ trunk/zoo-project/zoo-client/lib/tpl/payload_Execute.mustache	(revision 517)
@@ -1,4 +1,4 @@
 <wps:Execute service="WPS" version="1.0.0" xmlns:wps="http://www.opengis.net/wps/1.0.0" xmlns:ows="http://www.opengis.net/ows/1.1" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.opengis.net/wps/1.0.0
-../wpsExecute_request.xsd">
+../wpsExecute_request.xsd" language="{{language}}">
   <!-- template-version: 0.21 -->
 	<ows:Identifier>{{Identifier}}</ows:Identifier>
@@ -29,5 +29,5 @@
 		<wps:Input>
 			<ows:Identifier>{{identifier}}</ows:Identifier>
-			<wps:Reference xlink:href="{{href}}"/>
+			<wps:Reference xlink:href="{{href}}"{{#schema}} schema="{{shema}}"{{/schema}}{{#mimeType}} mimeType="{{mimeType}}"{{/mimeType}}{{#encoding}} encoding="{{encoding}}"{{/encoding}}/>
 		</wps:Input>
 {{/is_get}}
@@ -36,8 +36,8 @@
 			<ows:Identifier>{{identifier}}</ows:Identifier>
 			<wps:Reference xlink:href="{{href}}" method="{{method}}">
-{{#mimeType}}
-			  <wps:Header key="Content-type" value="{{mimeType}}" />
-{{/mimeType}}
-			  <wps:Body>{{{complexPayload}}}</wps:Body>
+{{#headers}}
+			  <wps:Header key="{{key}}" value="{{value}}" />
+{{/headers}}
+			  <wps:Body>{{{value}}}</wps:Body>
 			</wps:Reference>
 		</wps:Input>
@@ -48,6 +48,6 @@
       <ows:Identifier>{{identifier}}</ows:Identifier>
       <wps:Data>
-        <wps:ComplexData{{#schema}} schema="{{shema}}"{{/schema}}{{#mimeType}} mimeType="{{mimeType}}"{{/mimeType}}{{#encoding}} encoding="{{encoding}}"{{/encoding}}>
-        	{{{complexPayload}}}
+        <wps:ComplexData{{#schema}} schema="{{shema}}"{{/schema}}{{#mimeType}} mimeType="{{mimeType}}"{{/mimeType}}{{#encoding}} encoding="{{encoding}}"{{/encoding}}>{{#is_XML}}
+	 {{{value}}}{{/is_XML}}{{^is_XML}}<![CDATA[{{{value}}}]]>{{/is_XML}}
         </wps:ComplexData>
       </wps:Data>
@@ -59,7 +59,9 @@
 	<wps:ResponseForm>
 {{#RawDataOutput}}
+{{#DataOutputs}}
     <wps:RawDataOutput mimeType="{{mimeType}}">
       <ows:Identifier>{{identifier}}</ows:Identifier>
     </wps:RawDataOutput>
+{{/DataOutputs}}
 {{/RawDataOutput}}
 {{^RawDataOutput}}
@@ -67,5 +69,5 @@
 {{#DataOutputs}}
 {{#is_literal}}
-      <wps:Output>
+      <wps:Output{{#dataType}} dataType="{{dataType}}"{{/dataType}}{{#uom}} uom="{{uom}}"{{/uom}}>
         <ows:Identifier>{{identifier}}</ows:Identifier>
       </wps:Output>
Index: trunk/zoo-project/zoo-client/lib/tpl/payload_GetCapabilities.mustache
===================================================================
--- trunk/zoo-project/zoo-client/lib/tpl/payload_GetCapabilities.mustache	(revision 480)
+++ trunk/zoo-project/zoo-client/lib/tpl/payload_GetCapabilities.mustache	(revision 517)
@@ -1,3 +1,3 @@
-<wps:GetCapabilities xmlns:ows="http://www.opengis.net/ows/1.1" xmlns:wps="http://www.opengis.net/wps/1.0.0" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.opengis.net/wps/1.0.0 ../wpsGetCapabilities_request.xsd" language="en-CA" service="WPS">
+<wps:GetCapabilities xmlns:ows="http://www.opengis.net/ows/1.1" xmlns:wps="http://www.opengis.net/wps/1.0.0" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.opengis.net/wps/1.0.0 ../wpsGetCapabilities_request.xsd" language="{{language}}" service="WPS">
     <wps:AcceptVersions>
         <ows:Version>1.0.0</ows:Version>