Index: trunk/debian/changelog
===================================================================
--- trunk/debian/changelog	(revision 522)
+++ trunk/debian/changelog	(revision 523)
@@ -1,2 +1,10 @@
+zoo-project (1.4~devel01) UNRELEASED; urgency=low
+
+  * Added Gdal ZOO Services
+  * Added Cgal ZOO Services
+  * Added WPS Status Services
+
+ -- David Saggiorato <david@saggiorato.net>  Fri, 31 Oct 2014 17:54:34 +0100
+
 zoo-project (1.3.0-1~trusty10) trusty; urgency=low
 
Index: trunk/debian/control
===================================================================
--- trunk/debian/control	(revision 522)
+++ trunk/debian/control	(revision 523)
@@ -13,14 +13,14 @@
                libcurl4-gnutls-dev,
                libcgic-dev (>= 2.06),
-               libgdal-dev (>= 1.10.1-0~),
-               python-all (>= 2.6.6-3~),
-               python-all-dev (>= 2.6.6-3~),
+               libgdal-dev,
+               python-all (>= 2.6.6-3~) |  python-dev,
                libfcgi-dev,
                libxml2-dev,
                libxslt1-dev,
-               libmapserver1-dev
+               libcgal-dev,
+               libmozjs185-dev,
 Build-Conflicts: libcurl3-openssl-dev
 Standards-Version: 3.9.3
-X-Python-Version: >= 2.6
+X-Python-Version: >= 2.7
 Homepage: http://zoo-project.org
 
@@ -41,5 +41,5 @@
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         python (>=2.6), 
+         python (>=2.7), 
          python-gdal
 Description: This package contains the CGI ZOO Services
Index: trunk/debian/rules
===================================================================
--- trunk/debian/rules	(revision 522)
+++ trunk/debian/rules	(revision 523)
@@ -6,20 +6,36 @@
 
 override_dh_auto_configure:
-	cd zoo-project/zoo-kernel && autoconf && ./configure --with-python
+	cd zoo-project/zoo-kernel && autoconf && ./configure --with-python --with-js --with-cgi-dir=$(CURDIR)/debian/tmp/usr/lib/cgi-bin
 
 override_dh_auto_build:
 	dh_auto_build --builddirectory zoo-project/zoo-kernel
-	cd zoo-project/zoo-services/ogr/base-vect-ops && make
+	dh_auto_build --builddirectory zoo-project/zoo-services/cgal
+	dh_auto_build --builddirectory zoo-project/zoo-services/gdal/contour
+	dh_auto_build --builddirectory zoo-project/zoo-services/gdal/translate
+	dh_auto_build --builddirectory zoo-project/zoo-services/gdal/dem
+	dh_auto_build --builddirectory zoo-project/zoo-services/gdal/grid
+	dh_auto_build --builddirectory zoo-project/zoo-services/gdal/profile
+	dh_auto_build --builddirectory zoo-project/zoo-services/gdal/warp
+	dh_auto_build --builddirectory zoo-project/zoo-services/ogr/base-vect-ops
+	dh_auto_build --builddirectory zoo-project/zoo-services/ogr/ogr2ogr
+	dh_auto_build --builddirectory zoo-project/zoo-services/utils/status
 
 override_dh_auto_install:
 	dh_auto_install --builddirectory zoo-project/zoo-kernel
-	-mkdir -p $(CURDIR)/debian/tmp/usr/lib/cgi-bin
-	install -m755 $(CURDIR)/zoo-project/zoo-kernel/zoo_loader.cgi $(CURDIR)/debian/tmp/usr/lib/cgi-bin/
-	-mv -v $(CURDIR)/zoo-project/zoo-kernel/main.cfg $(CURDIR)/debian/tmp/usr/lib/cgi-bin/
-	install -m755 $(CURDIR)/zoo-project/zoo-services/ogr/base-vect-ops/cgi-env/ogr_service.zo $(CURDIR)/debian/tmp/usr/lib/cgi-bin/
-	-mv -v $(CURDIR)/zoo-project/zoo-services/ogr/base-vect-ops/cgi-env/*.zcfg $(CURDIR)/debian/tmp/usr/lib/cgi-bin/
-	install -m755 $(CURDIR)/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/ogr_sp.py $(CURDIR)/debian/tmp/usr/lib/cgi-bin/
-	-mv -v $(CURDIR)/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/*.zcfg $(CURDIR)/debian/tmp/usr/lib/cgi-bin/
+	dh_auto_install --builddirectory zoo-project/zoo-services/cgal
+	dh_auto_install --builddirectory zoo-project/zoo-services/gdal/contour
+	dh_auto_install --builddirectory zoo-project/zoo-services/gdal/translate
+	dh_auto_install --builddirectory zoo-project/zoo-services/gdal/dem
+	dh_auto_install --builddirectory zoo-project/zoo-services/gdal/grid
+	dh_auto_install --builddirectory zoo-project/zoo-services/gdal/profile
+	dh_auto_install --builddirectory zoo-project/zoo-services/gdal/warp
+	install -d $(CURDIR)/debian/tmp/usr/lib/cgi-bin/gdal/ndvi
+	install $(CURDIR)/zoo-project/zoo-services/gdal/ndvi/cgi-env/* $(CURDIR)/debian/tmp/usr/lib/cgi-bin/gdal/ndvi/
+	dh_auto_install --builddirectory zoo-project/zoo-services/ogr/base-vect-ops
+	dh_auto_install --builddirectory zoo-project/zoo-services/ogr/ogr2ogr
+	install -d $(CURDIR)/debian/tmp/usr/lib/cgi-bin/ogr/base-vect-ops-py
+	install $(CURDIR)/zoo-project/zoo-services/ogr/base-vect-ops-py/cgi-env/* $(CURDIR)/debian/tmp/usr/lib/cgi-bin/ogr/base-vect-ops-py/
+	dh_auto_install --builddirectory zoo-project/zoo-services/utils/status
 
-override_dh_auto_clean:
-	dh_auto_clean --builddirectory zoo-project/zoo-kernel
+#override_dh_auto_clean:
+#	dh_auto_clean --builddirectory zoo-project/zoo-kernel
Index: trunk/debian/source/format
===================================================================
--- trunk/debian/source/format	(revision 522)
+++ trunk/debian/source/format	(revision 523)
@@ -1,1 +1,1 @@
-3.0 (quilt)
+3.0 (native)
Index: trunk/debian/zoo-kernel.install
===================================================================
--- trunk/debian/zoo-kernel.install	(revision 522)
+++ trunk/debian/zoo-kernel.install	(revision 523)
@@ -1,2 +1,3 @@
 usr/lib/cgi-bin/zoo_loader.cgi
 usr/lib/cgi-bin/main.cfg
+zoo-project/zoo-api/js/*    usr/lib/cgi-bin/
Index: trunk/debian/zoo-services.install
===================================================================
--- trunk/debian/zoo-services.install	(revision 522)
+++ trunk/debian/zoo-services.install	(revision 523)
@@ -1,21 +1,9 @@
-usr/lib/cgi-bin/ogr_service.zo
-usr/lib/cgi-bin/ogr_sp.py
-usr/lib/cgi-bin/Boundary.zcfg
-usr/lib/cgi-bin/Buffer.zcfg
-usr/lib/cgi-bin/Centroid.zcfg
-usr/lib/cgi-bin/ConvexHull.zcfg
-usr/lib/cgi-bin/Difference.zcfg
-usr/lib/cgi-bin/Distance.zcfg
-usr/lib/cgi-bin/GetArea.zcfg
-usr/lib/cgi-bin/Intersection.zcfg
-usr/lib/cgi-bin/SymDifference.zcfg
-usr/lib/cgi-bin/Union.zcfg
-usr/lib/cgi-bin/BoundaryPy.zcfg
-usr/lib/cgi-bin/BufferPy.zcfg
-usr/lib/cgi-bin/CentroidPy.zcfg
-usr/lib/cgi-bin/ConvexHullPy.zcfg
-usr/lib/cgi-bin/DifferencePy.zcfg
-usr/lib/cgi-bin/IntersectionPy.zcfg
-usr/lib/cgi-bin/SymDifferencePy.zcfg
-usr/lib/cgi-bin/UnionPy.zcfg
-
+usr/lib/cgi-bin/cgal	usr/lib/cgi-bin/
+usr/lib/cgi-bin/gdal	usr/lib/cgi-bin/
+usr/lib/cgi-bin/ogr	usr/lib/cgi-bin/
+usr/lib/cgi-bin/demo.zcfg	usr/lib/cgi-bin/
+usr/lib/cgi-bin/GetStatus.zcfg	usr/lib/cgi-bin/
+usr/lib/cgi-bin/longProcess.zcfg	usr/lib/cgi-bin/
+usr/lib/cgi-bin/service.py	usr/lib/cgi-bin/
+usr/lib/cgi-bin/updateStatus.xsl	usr/lib/cgi-bin/
+usr/lib/cgi-bin/wps_status.zo	usr/lib/cgi-bin/